//! \file    MainWindowController.cpp
//! \brief   Implementation of the MainWindowController window for visual_YAO.
//! \version 2009/11/09 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane & MAYOMBO Alexis.

#include "include/MainWindowController.hpp"
#include <iostream>
//! \class MainWindowController & MainWindowController::getInstance() 
//! \brief Implementation of the MainWindow controller for visual_YAO.


using namespace std;
using namespace yao;

/****************************************** Implementation of MainWindowController() *********************************************************/
MainWindowController::MainWindowController():m_spc(NULL), m_directoryViewer(NULL), m_hat(NULL), m_insertFCT(NULL) 
{

	npTest = false;

}
/********************************************************* getInstance() ****************************************************************/
//MainWindowController & MainWindowController::getInstance() {

//	static MainWindowController instance;
	
//	return instance;
//}
/*******************************************************************/
//template <class T> void MainWindowController::Min(T x, T y) {

//	cout << "valeurs: " << x << y << endl;
	//return x<y ? x : y;
//}
/********************************************************* isStringLiteral(string aString) **********************************************************/
bool MainWindowController::isStringLiteral(string aString) {
	bool aBool = true;
	//Si le caractère à comparer est != de "la suite"; alors renvoie faux. Sinon renvoie vrai.
	for(int i=0; i < aString.size(); i++){
		if (aBool) {
			bool test = (!((aString[i] >= 'a' && aString[i] <= 'z') || (aString[i] >= 'A' && aString[i] <= 'Z') || 
				       (aString[i] >= '0' && aString[i] <= '9') || (aString[i] == '/')  || (aString[i] == '_')  || 
				       (aString[i] == '.') || (aString[i] == ' ') || (aString[i] == '-')))? false : true;
			
			if (test == false) 
				aBool = false;
			else
			 aBool = true;
			}
		else 
			return aBool;
	}
	 return aBool;
}
/********************************************************** isIdentifier(string aString) *******************************************/
bool MainWindowController::isIdentifier(string aString) {
	bool aBool = true;
	//Si le caractère à comparer est != de "la suite"; alors renvoie faux. Sinon renvoie vrai.
	for(int i=0; i < aString.size(); i++){
		if (aBool) {
			bool test = (!((aString[i] >= 'a' && aString[i] <= 'z') || (aString[i] >= 'A' && aString[i] <= 'Z') || 
				       (aString[i] >= '0' && aString[i] <= '9') || (aString[i] == '-')))? false : true;
			
			if (test == false) 
				aBool = false;
			else
			 aBool = true;
			}
		else 
			return aBool;
	}
	 return aBool;

    }
/********************************************************** isIntegerLiteral(string aString) *******************************************/
bool MainWindowController::isIntegerLiteral(string aString) {
	bool aBool = true;
	//Si le caractère à comparer est != de "la suite"; alors renvoie faux. Sinon renvoie vrai.
	for(int i=0; i < aString.size(); i++){
		if (aBool) {
			bool test = (!((aString[i] == 'e') || (aString[i] == 'E') || (aString[i] == '+') || (aString[i] == '-') ||
				       (aString[i] >= '0' && aString[i] <= '9')))? false : true;
			
			if (test == false) 
				aBool = false;
			else
			 aBool = true;
			}
		else 
			return aBool;
	}
	 return aBool;

    }


/********************************************************** isExponent(string aString) *******************************************/
bool MainWindowController::isExponent(string aString) {
	bool aBool = true;
	//Si le caractère à comparer est != de "la suite"; alors renvoie faux. Sinon renvoie vrai.
	for(int i=0; i < aString.size(); i++){
		if (aBool) {
			bool test = (!((aString[i] == 'e') || (aString[i] == 'E') || (aString[i] == '+') || (aString[i] == '-') ||
				       (aString[i] >= '0' && aString[i] <= '9')))? false : true;
			
			if (test == false) 
				aBool = false;
			else
			 aBool = true;
			}
		else 
			return aBool;
	}
	 return aBool;

    }


/********************************************************** setProjectNameInMWC(string name ) *******************************************/
void MainWindowController::setProjectNameInMWC(string name ) {

    m_projectNameInMWC = name;
}

/*********************************************************** getProjectNameFromMWC() ****************************************************/
string MainWindowController::getProjectNameFromMWC() {

  return m_projectNameInMWC;
}

/************************************************************ setConstant() ***************************************************************/
void MainWindowController::setConstant() {

    //m_Constant = new ConstantWindow(&m_theHeaderList);
}

/************************************************************  getConstant() **************************************************************/
/*ConstantWindow *MainWindowController::getConstant() {

        //m_Constant = new ConstantWindow();

    //return m_Constant = new ConstantWindow;
}*/

/****************************************************************************************************************************************/
//void MainWindowController::setHatName(std::string hat) {

//}

/************************************************************ getHatName() **************************************************************/
HatNameWindow *MainWindowController::getHatName() {

	//setProjectNameInMWC(getNewProjectName());		
	//string g = getProjectNameFromMWC();
	vector <string> headerList;
    //retur new HatNameWindow(headerList, );

}

/************************************************************ getContext() ***************************************************************/
//ContextWindow *MainWindowController::getContext() {

   //return m_Context = new ContextWindow;

//}

/************************************************************ getTraj() *****************************************************************/
TrajectoryWindow *MainWindowController::getTraj() {

   //return m_traj = new TrajectoryWindow();

}
/************************************************************* getSpace() ***************************************************************/

//SpaceWindow *MainWindowController::getSpace() {

   //return m_space = new SpaceWindow();
//}

/************************************************************* getOpera() ***************************************************************/

OperaWindow *MainWindowController::getOpera() {

   //return m_opera = new OperaWindow;
}

/************************************************************** getNetward() ************************************************************/

NetwardWindow *MainWindowController::getNetward() {

    //return m_netward = new NetwardWindow;
}

/************************************************************** getModul() **************************************************************/

/*ModulWindow *MainWindowController::getModul() {

    //return m_modul = new ModulWindow;
}*/

/*************************************************************** getCtin() **************************************************************/

ConnectionWindow *MainWindowController::getCtin() {

 	//   return m_ctin = new ConnectionWindow;
}

/**************************************************************** getOrder() ************************************************************/

OrderWindow *MainWindowController::getOrder() {

    //return m_order = new OrderWindow;
}
/**************************************************************** getInsertFCT() ********************************************************/

InsertFCTWindow *MainWindowController::getInsertFCT() {

    //return m_insertFCT = new InsertFCTWindow;
}


/**************************************************************** getNewProjectInstance() ***********************************************/
/*void MainWindowController::getNewProjectInstance() {

   // m_projectName = np->name;
  getNP();
	std::cout << //np->getNewProjectName()/////"Mon age!" << std::endl;
   //if (npTest) 
//	setProjectNameInMWC(np->getNewProjectName());
//	else
//	setProjectNameInMWC("not ready!");


//}

*/
/**************************************************************** getNP() ***************************************************************/
/*void MainWindowController::getNP() {
	np->show();
	
	//np = new NewProjectWindow;
	npTest = true;	   
}
*/
/***************************************************************** getSpaceController() *************************************************/
SpaceController MainWindowController::getSpaceController()
{
	
	SpaceController m_spc = SpaceController::getInstance();
    return m_spc;
}

/****************************************************************************************************************************************/
//void MainWindowController::setNewProjectName(std::string newProject) {

//}

/****************************************************************************************************************************************/
//std::string MainWindowController::getNewProjectName() {
	
//	return
//}

/*************************************************** setTheHeaderList(string theHeaderListString) ***************************************/
void MainWindowController::setTheHeaderList(string theHeaderListString) {

    m_theHeaderList.push_back(theHeaderListString);
}

/*************************************************** getTheHeaderList() *****************************************************************/
std::vector<std::string> MainWindowController::getTheHeaderList() {

    //setTheHeaderList("");
  //std::vector<std::string>m_theHeaderList m_theHeaderList;
   m_theHeaderList.push_back("test push_back");
    return m_theHeaderList;
}

/************************************************* setFileListController(string fileController) *****************************************/
void MainWindowController::setFileListController(string fileController) {

    m_hat->setFileList(fileController);
}

/************************************************* getTheTrajectoryTable() **************************************************************/
yao::Table<yao::Trajectory> MainWindowController::getTheTrajectoryTable(){

    return m_theTrajectoryTable;

}

/****************************************************************************************************************************************/


/****************************************************************************************************************************************/
MainWindowController::~MainWindowController() {

	//delete m_Constant;
}
