//! \file    OrderWindow.cpp
//! \brief   Implementation of the OrderWindow window for visual_YAO.
//! \version 2010/06/22 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: OrderWindow.cpp
  Nom de classe: OrderWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/OrderWindow.hpp"

using namespace std;
using namespace yao;
//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

/***************************************** Implementation of the Construtor OrderWindow() *************************************************/
OrderWindow::OrderWindow(Table <Trajectory> *aTrajectoryTable, Table <Space> *aSpaceTable, Table <Operator> *anOperatorTable, Table <Modul> *aModulTable, QWidget *parent) : QWidget(parent) {

	setupUi(this);

	m_trajectoryTable	= aTrajectoryTable;
	m_spaceTable		= aSpaceTable;
	m_operatorTable		= anOperatorTable;
	m_modulTable		= aModulTable;

	setFixedWidth(baseSize().width() + 765);
	
	m_orderModel	= new QStandardItemModel(0, 5);
}

/**************************************************** Implementation of cloveEvent() method. ***********************************************/
void OrderWindow::closeEvent(QCloseEvent *event) {

	emit orderWindowIsClosed(10);
}

/***********************************************************************/
