/*
  Nom du Fichier: OrderWindow.hpp
  Nom de classe: OrderWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef ORDERWINDOW_HPP
#define ORDERWINDOW_HPP


#include "../../ui_orderwindow.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Operator.hpp"
#include "../../../YAOObjects/Trajectory.hpp"
#include "../../../YAOObjects/Order.hpp"
#include <QStandardItemModel>

class OrderWindow : public QWidget, public Ui::OrderWindow {

	Q_OBJECT

	public :
            OrderWindow(yao::Table <yao::Trajectory> *aTrajectoryTable, yao::Table <yao::Space> *aSpaceTable, yao::Table <yao::Operator> *anOperatorTable, yao::Table <yao::Modul> *aModulTable, QWidget *parent=0);

	private slots:

	signals:
		void orderWindowIsClosed(int );

	protected:
		void closeEvent(QCloseEvent *event);

	private :
		QStandardItemModel *m_orderModel;
		yao::Table <yao::Trajectory> *m_trajectoryTable;
		yao::Table <yao::Space> *m_spaceTable;
		yao::Table <yao::Operator> *m_operatorTable;
		yao::Table <yao::Modul> *m_modulTable;

};
#endif // ORDERWINDOW_HPP
